Tileset = Core.class(Sprite)

function Tileset:init()
	-- BG
	application:setBackgroundColor(0x1234AA)

	-- SHOW OUTLINES
	isDEMO = false

	-- TITLE
	local mytitle = TextField.new(nil, "CREATED TILESET")
	mytitle:setAnchorPoint(0.5, 0.5)
	mytitle:setScale(3)
	mytitle:setTextColor(0x00ff00)
	mytitle:setPosition(myappwidth / 2, 1 * myappheight / 10)
	self:addChild(mytitle)

	-- CREATE TILESET
	self:createTileset() -- from one tile!
	self:showTileset()

	-- LISTENERS
	self:addEventListener("enterBegin", self.onTransitionInBegin, self)
	self:addEventListener("enterEnd", self.onTransitionInEnd, self)
	self:addEventListener("exitBegin", self.onTransitionOutBegin, self)
	self:addEventListener("exitEnd", self.onTransitionOutEnd, self)
end

-- FUNCTIONS
function Tileset:createTileset()
	local myTSsprite = Sprite.new()
	local decotex = Texture.new("GFX/tiledeco_32_x01.png") -- 1 TILE IS HERE
	local tw, th = decotex:getWidth(), decotex:getHeight()
	local i = 1

	-- THE PROCESS
	for r = 1, 5 do
		for c = 1, 11 do
			local x, y = (c - 1) * tw, (r - 1) * th

			-- FIRST SET
			if i == 1 then
				myTSsprite:addChild(tilesType("gout", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("hout", c, r, decotex, tw, th, x, y))
			elseif i == 2 then
				myTSsprite:addChild(tilesType("UP", c, r, decotex, tw, th, x, y))
			elseif i == 3 then
				myTSsprite:addChild(tilesType("aout", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("bout", c, r, decotex, tw, th, x, y))
			elseif i == 12 then
				myTSsprite:addChild(tilesType("LEFT", c, r, decotex, tw, th, x, y))
			elseif i == 13 then
				-- nothing here!
			elseif i == 14 then
				myTSsprite:addChild(tilesType("RIGHT", c, r, decotex, tw, th, x, y))
			elseif i == 23 then
				myTSsprite:addChild(tilesType("eout", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("fout", c, r, decotex, tw, th, x, y))
			elseif i == 24 then
				myTSsprite:addChild(tilesType("DOWN", c, r, decotex, tw, th, x, y))
			elseif i == 25 then
				myTSsprite:addChild(tilesType("cout", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("dout", c, r, decotex, tw, th, x, y))

			-- SECOND SET
			elseif i == 34 then
				myTSsprite:addChild(tilesType("eout", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("fout", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("hout", c, r, decotex, tw, th, x, y))
			elseif i == 35 then
				myTSsprite:addChild(tilesType("UP", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("DOWN", c, r, decotex, tw, th, x, y))
			elseif i == 36 then
				myTSsprite:addChild(tilesType("aout", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("bout", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("dout", c, r, decotex, tw, th, x, y))

			-- THIRD SET
			elseif i == 4 then
				myTSsprite:addChild(tilesType("aout", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("bout", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("gout", c, r, decotex, tw, th, x, y))
			elseif i == 15 then
				myTSsprite:addChild(tilesType("LEFT", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("RIGHT", c, r, decotex, tw, th, x, y))
			elseif i == 26 then
				myTSsprite:addChild(tilesType("cout", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("dout", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("fout", c, r, decotex, tw, th, x, y))

			-- FOURTH SET
			elseif i == 37 then
				myTSsprite:addChild(tilesType("LEFT", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("RIGHT", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("ed", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("ha", c, r, decotex, tw, th, x, y))

			-- FIFTH SET
			elseif i == 5 then
				myTSsprite:addChild(tilesType("cinrp180", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("dinrp90", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("gout", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("hout", c, r, decotex, tw, th, x, y))
			elseif i == 6 then
				myTSsprite:addChild(tilesType("UP", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("cinrp180", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("dinrp90", c, r, decotex, tw, th, x, y))
			elseif i == 7 then
				myTSsprite:addChild(tilesType("UP", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("einrm90", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("finrp180", c, r, decotex, tw, th, x, y))
			elseif i == 8 then
				myTSsprite:addChild(tilesType("aout", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("bout", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("einrm90", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("finrp180", c, r, decotex, tw, th, x, y))
			elseif i == 16 then
				myTSsprite:addChild(tilesType("LEFT", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("cinrp180", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("dinrp90", c, r, decotex, tw, th, x, y))
			elseif i == 17 then
				myTSsprite:addChild(tilesType("cinrp180", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("dinrp90", c, r, decotex, tw, th, x, y))
			elseif i == 18 then
				myTSsprite:addChild(tilesType("einrm90", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("finrp180", c, r, decotex, tw, th, x, y))
			elseif i == 19 then
				myTSsprite:addChild(tilesType("RIGHT", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("einrm90", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("finrp180", c, r, decotex, tw, th, x, y))
			elseif i == 27 then
				myTSsprite:addChild(tilesType("LEFT", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("ainrp90", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("binr0", c, r, decotex, tw, th, x, y))
			elseif i == 28 then
				myTSsprite:addChild(tilesType("ainrp90", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("binr0", c, r, decotex, tw, th, x, y))
			elseif i == 29 then
				myTSsprite:addChild(tilesType("ginr0", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("hinrm90", c, r, decotex, tw, th, x, y))
			elseif i == 30 then
				myTSsprite:addChild(tilesType("RIGHT", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("ginr0", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("hinrm90", c, r, decotex, tw, th, x, y))
			elseif i == 38 then -- SPECIAL ED
				myTSsprite:addChild(tilesType("LEFT", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("ainrp90", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("binr0", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("cinrp180", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("ed", c, r, decotex, tw, th, x, y))
			elseif i == 39 then
				myTSsprite:addChild(tilesType("DOWN", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("ainrp90", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("binr0", c, r, decotex, tw, th, x, y))
			elseif i == 40 then
				myTSsprite:addChild(tilesType("DOWN", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("ginr0", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("hinrm90", c, r, decotex, tw, th, x, y))
			elseif i == 41 then -- SPECIAL ED
				myTSsprite:addChild(tilesType("RIGHT", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("ed", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("finrp180", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("ginr0", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("hinrm90", c, r, decotex, tw, th, x, y))

			-- SIXTH SET
			elseif i == 49 then
				myTSsprite:addChild(tilesType("LEFT", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("ainrp90", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("binr0", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("cinrp180", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("dinrp90", c, r, decotex, tw, th, x, y))
			elseif i == 50 then
				myTSsprite:addChild(tilesType("ainrp90", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("binr0", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("cinrp180", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("dinrp90", c, r, decotex, tw, th, x, y))
			elseif i == 51 then
				myTSsprite:addChild(tilesType("einrm90", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("finrp180", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("ginr0", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("hinrm90", c, r, decotex, tw, th, x, y))
			elseif i == 52 then
				myTSsprite:addChild(tilesType("RIGHT", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("einrm90", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("finrp180", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("ginr0", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("hinrm90", c, r, decotex, tw, th, x, y))

			-- SEVENTH SET
			elseif i == 9 then
				myTSsprite:addChild(tilesType("UP", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("cinrp180", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("dinrp90", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("einrm90", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("finrp180", c, r, decotex, tw, th, x, y))
			elseif i == 10 then
				myTSsprite:addChild(tilesType("ainrp90", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("binr0", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("einrm90", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("finrp180", c, r, decotex, tw, th, x, y))
			elseif i == 11 then
			elseif i == 20 then
				myTSsprite:addChild(tilesType("cinrp180", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("dinrp90", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("einrm90", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("finrp180", c, r, decotex, tw, th, x, y))
			elseif i == 21 then
				myTSsprite:addChild(tilesType("cinrp180", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("dinrp90", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("ginr0", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("hinrm90", c, r, decotex, tw, th, x, y))
			elseif i == 22 then
			elseif i == 31 then
				myTSsprite:addChild(tilesType("ainrp90", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("binr0", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("ginr0", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("hinrm90", c, r, decotex, tw, th, x, y))
			elseif i == 42 then
				myTSsprite:addChild(tilesType("DOWN", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("ainrp90", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("binr0", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("ginr0", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("hinrm90", c, r, decotex, tw, th, x, y))

			-- EIGHTH SET
			elseif i == 32 then
				myTSsprite:addChild(tilesType("ainrp90", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("binr0", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("einrm90", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("finrp180", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("ginr0", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("hinrm90", c, r, decotex, tw, th, x, y))
			elseif i == 33 then
				myTSsprite:addChild(tilesType("ainrp90", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("binr0", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("cinrp180", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("dinrp90", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("ginr0", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("hinrm90", c, r, decotex, tw, th, x, y))
			elseif i == 43 then
				myTSsprite:addChild(tilesType("cinrp180", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("dinrp90", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("einrm90", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("finrp180", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("ginr0", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("hinrm90", c, r, decotex, tw, th, x, y))
			elseif i == 44 then
				myTSsprite:addChild(tilesType("ainrp90", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("binr0", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("cinrp180", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("dinrp90", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("einrm90", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("finrp180", c, r, decotex, tw, th, x, y))

			-- NINETH SET
			elseif i == 53 then
				myTSsprite:addChild(tilesType("ainrp90", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("binr0", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("cinrp180", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("dinrp90", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("einrm90", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("finrp180", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("ginr0", c, r, decotex, tw, th, x, y))
				myTSsprite:addChild(tilesType("hinrm90", c, r, decotex, tw, th, x, y))
			end

			i += 1
		end
	end

	-- SAVE PIECES TO TILESET
	local myfinalts = RenderTarget.new(myTSsprite:getWidth(), myTSsprite:getHeight())
	myfinalts:draw(myTSsprite)

	-- SAVE TILESET TO FILE
	myfinalts:save("|D|finalts.png")

	-- make tileset texture accessible
	self.myfinaltstex = Texture.new("|D|finalts.png")
	self.tw, self.th = tw, th
	self.c, self.r = self.myfinaltstex:getWidth() / tw, self.myfinaltstex:getHeight() / th
end

function Tileset:showTileset()
	local mytsbmp = Bitmap.new(self.myfinaltstex)
	mytsbmp:setAnchorPoint(0.5, 0.5)
	mytsbmp:setPosition(myappwidth / 2, myappheight / 2)
	self:addChild(mytsbmp)

	-- PAN & ZOOM
	mytsbmp.isdragged = false
	mytsbmp.x0, mytsbmp.y0 = 0, 0

	-- PAN
	mytsbmp:addEventListener(Event.MOUSE_DOWN, function(e)
		e:stopPropagation()
		mytsbmp.x0, mytsbmp.y0 = e.x, e.y
		mytsbmp.isdragged = true
	end)
	mytsbmp:addEventListener(Event.MOUSE_MOVE, function(e)
		if mytsbmp.isdragged then
			e:stopPropagation()
			local dx = e.x - mytsbmp.x0
			local dy = e.y - mytsbmp.y0
			mytsbmp:setX(mytsbmp:getX() + dx)
			mytsbmp:setY(mytsbmp:getY() + dy)
--			print(mytsbmp:getX(), mytsbmp:getY())
			if mytsbmp:getX() + mytsbmp:getWidth() / 2 - 3 * self.tw <= 0 then
				mytsbmp:setX(-mytsbmp:getWidth() / 2 + 3 * self.tw)
			end
			if mytsbmp:getX() - mytsbmp:getWidth() / 2 + 3 * self.tw >= myappwidth then
				mytsbmp:setX(myappwidth + mytsbmp:getWidth() / 2 - 3 * self.tw)
			end
			if mytsbmp:getY() + mytsbmp:getHeight() / 2 - 3 * self.th <= 0 then
				mytsbmp:setY(-mytsbmp:getHeight() / 2 + 3 * self.th)
			end
			if mytsbmp:getY() - mytsbmp:getHeight() / 2 + 3 * self.th >= myappheight then
				mytsbmp:setY(myappheight + mytsbmp:getHeight() / 2 - 3 * self.th)
			end
			mytsbmp.x0 = e.x
			mytsbmp.y0 = e.y
		end
	end)
	mytsbmp:addEventListener(Event.MOUSE_UP, function(e)
		if mytsbmp.isdragged then
			e:stopPropagation()
			mytsbmp.isdragged = false
		end
	end)
	-- ZOOM
	mytsbmp.myscale = 0
	mytsbmp:addEventListener(Event.MOUSE_WHEEL, function(e)
		print(e.wheel, mytsbmp.myscale)
		mytsbmp.myscale = mytsbmp:getScale() + e.wheel / 700
		mytsbmp:setScale(mytsbmp.myscale)
		if mytsbmp:getScale() <= 0.5 then mytsbmp:setScale(0.5) end
		if mytsbmp:getScale() >= 5 then mytsbmp:setScale(5) end
	end)
end

-- GAME LOOP
function Tileset:onEnterFrame(e)
end

-- EVENT LISTENERS
function Tileset:onTransitionInBegin()
	self:addEventListener(Event.ENTER_FRAME, self.onEnterFrame, self)
end

function Tileset:onTransitionInEnd()
	self:myKeysPressed()
end

function Tileset:onTransitionOutBegin()
	self:removeEventListener(Event.ENTER_FRAME, self.onEnterFrame, self)
end

function Tileset:onTransitionOutEnd()
end

-- KEYS HANDLER
function Tileset:myKeysPressed()
	self:addEventListener(Event.KEY_DOWN, function(e)
		-- for mobiles and desktops
		if e.keyCode == KeyCode.BACK or e.keyCode == KeyCode.ESC then
			scenemanager:changeScene("menu", 1, transitions[2], easing.outBack)
		end
	end)
end
