--[[
	CREATE THE APPROPRIATE TILE BASED ON ITS POSITION IN THE TILEMAP
]]

function tilesType(xdirection, xc, xr, xdecotex, xtw, xth, x, y)
	if xdirection == "UP" or xdirection == "DOWN" or xdirection == "LEFT" or xdirection == "RIGHT" then
		local mybmp = Bitmap.new(xdecotex)
		if xdirection == "UP" then
			mybmp:setPosition((xc - 1) * xtw, (xr - 1) * xth)
		elseif xdirection == "DOWN" then
			mybmp:setRotation(180)
			mybmp:setPosition((xc - 1) * xtw + xtw, (xr - 1) * xth + xth)
		elseif xdirection == "LEFT" then
			mybmp:setRotation(-90)
			mybmp:setPosition((xc - 1) * xtw, (xr - 1) * xth + xth)
		elseif xdirection == "RIGHT" then
			mybmp:setRotation(90)
			mybmp:setPosition((xc - 1) * xtw + xtw, (xr - 1) * xth)
		end
		return mybmp
	else
		local shape = Shape.new()
		local thick = 1
		shape:setFillStyle(Shape.TEXTURE, xdecotex)

	-- OUTS
		if xdirection == "aout" then
			if isDEMO then shape:setLineStyle(thick, 0x000000) end
			shape:beginPath()
			shape:moveTo(0, 0)
			shape:lineTo(xtw, 0)
			shape:lineTo(0, xth)
			shape:lineTo(0, 0)
			shape:endPath()
			shape:setPosition(x, y)
		elseif xdirection == "bout" then
			if isDEMO then shape:setLineStyle(thick, 0xffffff) end
			shape:beginPath()
			shape:moveTo(0, 0)
			shape:lineTo(xtw, 0)
			shape:lineTo(xtw, xth)
			shape:lineTo(0, 0)
			shape:endPath()
			shape:setRotation(90)
			shape:setPosition(x + 1 * xtw, y + 0 * xth)
		elseif xdirection == "cout" then
			if isDEMO then shape:setLineStyle(thick, 0xffff00) end
			shape:beginPath()
			shape:moveTo(0, 0)
			shape:lineTo(xtw, 0)
			shape:lineTo(0, xth)
			shape:lineTo(0, 0)
			shape:endPath()
			shape:setRotation(90)
			shape:setPosition(x + 1 * xtw, y + 0 * xth)
		elseif xdirection == "dout" then
			if isDEMO then shape:setLineStyle(thick, 0xff00ff) end
			shape:beginPath()
			shape:moveTo(0, 0)
			shape:lineTo(xtw, 0)
			shape:lineTo(xtw, xth)
			shape:lineTo(0, 0)
			shape:endPath()
			shape:setRotation(180)
			shape:setPosition(x + 1 * xtw, y + 1 * xth)
		elseif xdirection == "eout" then
			if isDEMO then shape:setLineStyle(thick, 0xff0000) end
			shape:beginPath()
			shape:moveTo(0, 0)
			shape:lineTo(xtw, 0)
			shape:lineTo(0, xth)
			shape:lineTo(0, 0)
			shape:endPath()
			shape:setRotation(-180)
			shape:setPosition(x + 1 * xtw, y + 1 * xth)
		elseif xdirection == "fout" then
			if isDEMO then shape:setLineStyle(thick, 0x00ffff) end
			shape:beginPath()
			shape:moveTo(0, 0)
			shape:lineTo(xtw, 0)
			shape:lineTo(xtw, xth)
			shape:lineTo(0, 0)
			shape:endPath()
			shape:setRotation(-90)
			shape:setPosition(x + 0 * xtw, y + 1 * xth)
		elseif xdirection == "gout" then
			if isDEMO then shape:setLineStyle(thick, 0x00ff00) end
			shape:beginPath()
			shape:moveTo(0, 0)
			shape:lineTo(xtw, 0)
			shape:lineTo(0, xth)
			shape:lineTo(0, 0)
			shape:endPath()
			shape:setRotation(-90)
			shape:setPosition(x + 0 * xtw, y + 1 * xth)
		elseif xdirection == "hout" then
			if isDEMO then shape:setLineStyle(thick, 0x0000ff) end
			shape:beginPath()
			shape:moveTo(0, 0)
			shape:lineTo(xtw, 0)
			shape:lineTo(xtw, xth)
			shape:lineTo(0, 0)
			shape:endPath()
			shape:setPosition(x + 0 * xtw, y + 0 * xth)

	-- INS
		elseif xdirection == "ainrp90" then
			if isDEMO then shape:setLineStyle(thick, 0x000000) end
			shape:beginPath()
			shape:moveTo(0, 0)
			shape:lineTo(xtw / 2, xth / 2)
			shape:lineTo(0, xth / 2)
			shape:lineTo(0, 0)
			shape:endPath()
			shape:setRotation(90)
			shape:setPosition(x + 1 * xtw, y + 0 * xth)
		elseif xdirection == "binr0" then
			if isDEMO then shape:setLineStyle(thick, 0xffffff) end
			shape:beginPath()
			shape:moveTo(xtw / 2, xth / 2)
			shape:lineTo(xtw, 0)
			shape:lineTo(xtw, xth / 2)
			shape:lineTo(xtw / 2, xth / 2)
			shape:endPath()
			shape:setPosition(x + 0 * xtw, y + 0 * xth)
		elseif xdirection == "cinrp180" then
			if isDEMO then shape:setLineStyle(thick, 0xffff00) end
			shape:beginPath()
			shape:moveTo(0, 0)
			shape:lineTo(xtw / 2, xth / 2)
			shape:lineTo(0, xth / 2)
			shape:lineTo(0, 0)
			shape:endPath()
			shape:setRotation(180)
			shape:setPosition(x + 1 * xtw, y + 1 * xth)
		elseif xdirection == "dinrp90" then
			if isDEMO then shape:setLineStyle(thick, 0xff00ff) end
			shape:beginPath()
			shape:moveTo(xtw, 0)
			shape:lineTo(xtw, xth / 2)
			shape:lineTo(xtw / 2, xth / 2)
			shape:lineTo(xth, 0)
			shape:endPath()
			shape:setRotation(90)
			shape:setPosition(x + 1 * xtw, y + 0 * xth)
		elseif xdirection == "einrm90" then
			if isDEMO then shape:setLineStyle(thick, 0xff0000) end
			shape:beginPath()
			shape:moveTo(0, 0)
			shape:lineTo(xtw / 2, xth / 2)
			shape:lineTo(0, xth / 2)
			shape:lineTo(0, 0)
			shape:endPath()
			shape:setRotation(-90)
			shape:setPosition(x + 0 * xtw, y + 1 * xth)
		elseif xdirection == "finrp180" then
			if isDEMO then shape:setLineStyle(thick, 0x00ffff) end
			shape:beginPath()
			shape:moveTo(xtw, 0)
			shape:lineTo(xtw, xth / 2)
			shape:lineTo(xtw / 2, xth / 2)
			shape:lineTo(xtw, 0)
			shape:endPath()
			shape:setRotation(180)
			shape:setPosition(x + 1 * xtw, y + 1 * xth)
		elseif xdirection == "ginr0" then
			if isDEMO then shape:setLineStyle(thick, 0x00ff00) end
			shape:beginPath()
			shape:moveTo(0, 0)
			shape:lineTo(xtw / 2, xth / 2)
			shape:lineTo(0, xth / 2)
			shape:lineTo(0, 0)
			shape:endPath()
			shape:setPosition(x + 0 * xtw, y + 0 * xth)
		elseif xdirection == "hinrm90" then
			if isDEMO then shape:setLineStyle(thick, 0x0000ff) end
			shape:beginPath()
			shape:moveTo(xtw, 0)
			shape:lineTo(xtw, xth / 2)
			shape:lineTo(xtw / 2, xth / 2)
			shape:lineTo(xtw, 0)
			shape:endPath()
			shape:setRotation(-90)
			shape:setPosition(x + 0 * xtw, y + 1 * xth)

	-- SPECIALS
		elseif xdirection == "ed" then
			if isDEMO then shape:setLineStyle(thick, 0xff0000) end
			shape:beginPath()
			shape:moveTo(0, 0)
			shape:lineTo(xtw, 0)
			shape:lineTo(xtw / 2, xth / 2)
			shape:endPath()
			shape:setRotation(180)
			shape:setPosition(x + 1 * xtw, y + 1 * xth)
		elseif xdirection == "ha" then
			if isDEMO then shape:setLineStyle(thick, 0x0000ff) end
			shape:beginPath()
			shape:moveTo(0, 0)
			shape:lineTo(xtw, 0)
			shape:lineTo(xtw / 2, xth / 2)
			shape:lineTo(0, 0)
			shape:endPath()
			shape:setPosition(x, y)

		end

		return shape
	end
end
