Menu = Core.class(Sprite)

function Menu:init()
	-- BG
	application:setBackgroundColor(0x1234AA)

	-- TITLE
	local mytitle = TextField.new(nil, "ONE TILE TO TILESET")
	mytitle:setAnchorPoint(0.5, 0.5)
	mytitle:setScale(5)
	mytitle:setTextColor(0xffffee)
	mytitle:setPosition(myappwidth / 2, 2 * myappheight / 10)
	self:addChild(mytitle)

	-- BUTTONS
	--function ButtonText:init(text, tfont, tcolor, tscalex, tscaley, upState, downState)
	local mybtnmap = ButtonText.new("!CREATE TILESET!", nil, 0xffff00, 5, 6)
	mybtnmap:setPosition(myappwidth / 2, 4 * myappheight / 10)
	mybtnmap:addEventListener("click", function()
		scenemanager:changeScene("tileset", 1, transitions[1], easing.outBack)
	end)
	self:addChild(mybtnmap)

	-- LISTENERS
	self:addEventListener("enterBegin", self.onTransitionInBegin, self)
	self:addEventListener("enterEnd", self.onTransitionInEnd, self)
	self:addEventListener("exitBegin", self.onTransitionOutBegin, self)
	self:addEventListener("exitEnd", self.onTransitionOutEnd, self)
end

-- GAME LOOP
function Menu:onEnterFrame(e)
end

-- EVENT LISTENERS
function Menu:onTransitionInBegin()
	self:addEventListener(Event.ENTER_FRAME, self.onEnterFrame, self)
end

function Menu:onTransitionInEnd()
	self:myKeysPressed()
end

function Menu:onTransitionOutBegin()
	self:removeEventListener(Event.ENTER_FRAME, self.onEnterFrame, self)
end

function Menu:onTransitionOutEnd()
end

-- KEYS HANDLER
function Menu:myKeysPressed()
	self:addEventListener(Event.KEY_DOWN, function(e)
		-- for mobiles and desktops
		if e.keyCode == KeyCode.BACK or e.keyCode == KeyCode.ESC then
			application:exit()
		end
	end)
end
